# Мониторинг памяти

Для анализа аллокаций предусмотрена аннотация `&МониторингПамяти`.

### Аннотация

```bsl
&МониторингПамяти
Процедура ПриСозданииОбъекта()
```

### API

```bsl
Конфигурация.ДобавитьМониторингПамяти();
```

### Пример

```bsl
&МониторингПамяти
Процедура ПриСозданииОбъекта()
КонецПроцедуры

&Бенчмарк
&Параметры(100)
&Параметры(1000)
Процедура Бенчмарк(Количество) Экспорт
	Строка = "";
	Для к = 1 По Количество Цикл
		Строка = Строка + "Просто текст";
	КонецЦикла;
КонецПроцедуры
```

### Вывод

| Method   | Количество |       Mean |      StdErr |   StdDev |     Median |     Op/s |   Allocated |
|----------|-----------:|-----------:|------------:|---------:|-----------:|---------:|------------:|
| Бенчмарк |        100 |   43.64 us |    666.4 ns | 3.650 us |   42.46 us | 22,916.4 |    126.9 KB |
| Бенчмарк |      1,000 | 1,280.5 us | 21,438.1 ns | 117.4 us | 1,220.5 us |    781.0 | 11,809.4 KB |
