# Параметризация

С помощью аннотации `&Параметры` можно задать параметры для полей класса и методов бенчмарков.

### API

```bsl
// Поле класса
Конфигурация.ДобавитьПараметр("ИмяПоля", 100);
```

```bsl
// Параметры метода бенчмарка
Параметры = Новый Массив();
Параметры.Добавить(100);
Параметры.Добавить(Ложь);
ДескрипторБенчмарка.ДобавитьПараметры(Параметры);
```

### Пример

```bsl
&Параметры(5, 0)
Перем ДобавляемаяЗадержка Экспорт; // Число

&Бенчмарк
&Параметры(100, 10)
&Параметры(100, 20)
&Параметры(200, 10)
&Параметры(200, 20)
Процедура Бенчмарк(Задержка1, Задержка2) Экспорт
	Приостановить(Задержка1 + Задержка2 + ДобавляемаяЗадержка);
КонецПроцедуры
```

### Вывод

| Method   | ДобавляемаяЗадержка | Задержка1 | Задержка2 |     Mean |   StdErr |   StdDev |   Median |  Op/s |
|----------|--------------------:|----------:|----------:|---------:|---------:|---------:|---------:|------:|
| Бенчмарк |                   0 |       100 |        10 | 110.9 ms | 22.06 us | 85.44 us | 111.0 ms | 9.015 |
| Бенчмарк |                   0 |       100 |        20 | 120.9 ms | 24.96 us | 96.68 us | 121.0 ms | 8.270 |
| Бенчмарк |                   0 |       200 |        10 | 210.9 ms | 17.05 us | 66.04 us | 211.0 ms | 4.740 |
| Бенчмарк |                   0 |       200 |        20 | 220.9 ms | 15.21 us | 58.90 us | 221.0 ms | 4.526 |
| Бенчмарк |                   5 |       100 |        10 | 115.9 ms | 18.02 us | 69.80 us | 115.9 ms | 8.626 |
| Бенчмарк |                   5 |       100 |        20 | 125.9 ms | 15.85 us | 61.40 us | 126.0 ms | 7.941 |
| Бенчмарк |                   5 |       200 |        10 | 215.9 ms | 21.92 us | 84.91 us | 216.0 ms | 4.632 |
| Бенчмарк |                   5 |       200 |        20 | 225.9 ms | 16.34 us | 63.28 us | 225.9 ms | 4.426 |
