# Сортировка отчета

### Аннотации

```bsl
// Сортировка результатов по убыванию производительности (от лучшего к худшему)
&СортировкаОтБыстрыхКМедленным
Процедура ПриСозданииОбъекта()

// Сортировка результатов по возрастанию времени выполнения (от худшего к лучшему)
&СортировкаОтМедленныхКБыстрым
Процедура ПриСозданииОбъекта()

// Сортировка результатов по наименованию метода бенчмарка
&СортировкаПоМетоду
Процедура ПриСозданииОбъекта()
```

### API

```bsl
Конфигурация.УстановитьСортировкуОтчета(СортировкиОтчетаБенчмарков.ПоУмолчанию);
Конфигурация.УстановитьСортировкуОтчета(СортировкиОтчетаБенчмарков.ОтБыстрыхКМедленным);
Конфигурация.УстановитьСортировкуОтчета(СортировкиОтчетаБенчмарков.ОтМедленныхКБыстрым);
Конфигурация.УстановитьСортировкуОтчета(СортировкиОтчетаБенчмарков.ПоМетоду);
```

### Пример

```bsl
&Параметры(1, 2, 3)
Перем Множитель Экспорт;

&СортировкаОтБыстрыхКМедленным
Процедура ПриСозданииОбъекта()
КонецПроцедуры

&Бенчмарк
Процедура Медленный() Экспорт
	Приостановить(Множитель * 20);
КонецПроцедуры

&Бенчмарк
Процедура Быстрый() Экспорт
	Приостановить(Множитель * 10);
КонецПроцедуры
```

### Вывод

| Method    | Множитель |     Mean |   StdErr |   StdDev |   Median |  Op/s |
|-----------|----------:|---------:|---------:|---------:|---------:|------:|
| Быстрый   |         1 | 10.98 ms | 4.183 us | 16.20 us | 10.99 ms | 91.04 |
| Быстрый   |         2 | 20.95 ms | 10.44 us | 40.43 us | 20.97 ms | 47.72 |
| Медленный |         1 | 20.97 ms | 7.558 us | 29.27 us | 20.97 ms | 47.70 |
| Быстрый   |         3 | 30.96 ms | 15.85 us | 61.40 us | 30.96 ms | 32.30 |
| Медленный |         2 | 40.92 ms | 20.75 us | 80.36 us | 40.95 ms | 24.44 |
| Медленный |         3 | 60.96 ms | 12.76 us | 49.42 us | 60.96 ms | 16.40 |

